//
// Generated by SwagGen
// https://github.com/yonaskolb/SwagGen
//

import Foundation
import JSONUtilities

public class Utilisateur: JSONDecodable, JSONEncodable, PrettyPrintable {

    public var id: String?

    public var nom: String?

    public var prenom: String?

    public init(id: String? = nil, nom: String? = nil, prenom: String? = nil) {
        self.id = id
        self.nom = nom
        self.prenom = prenom
    }

    public required init(jsonDictionary: JSONDictionary) throws {
        id = jsonDictionary.json(atKeyPath: "id")
        nom = jsonDictionary.json(atKeyPath: "nom")
        prenom = jsonDictionary.json(atKeyPath: "prenom")
    }

    public func encode() -> JSONDictionary {
        var dictionary: JSONDictionary = [:]
        if let id = id {
            dictionary["id"] = id
        }
        if let nom = nom {
            dictionary["nom"] = nom
        }
        if let prenom = prenom {
            dictionary["prenom"] = prenom
        }
        return dictionary
    }

    /// pretty prints all properties including nested models
    public var prettyPrinted: String {
        return "\(Swift.type(of: self)):\n\(encode().recursivePrint(indentIndex: 1))"
    }
}
